# Settings

# 3. Settings

FMOD For Unreal adds a number of configuration options to the Project Settings editor.

Access the settings by opening the Project Settings editor from the Edit menu, then navigate to the FMOD Studio plugin settings:

All of the settings are stored in the default engine configuration file and can be manually edited there if desired.

## 3.1 Basic

### 3.1.1 Load All Banks

When enabled the metadata from all FMOD bank files is loaded at startup.

    Default: Enabled

### 3.1.2 Load All Sample Data

When enabled the sample data from all FMOD bank files is loaded at startup. Only effective when Load All Banks is also enabled.

    Default: Disabled

### 3.1.3 Enable Live Update

When enabled FMOD Studio Live Update can connect to non-final builds of the game while running.

    Default: Enabled

### 3.1.4 Enable Editor Live Update

When enabled FMOD Studio Live Update can connect to the editor.

    Default: Disabled

### 3.1.5 Bank Output Directory

Path to the FMOD Studio built banks output directory, relative to the project's Content directory. See Studio Bank Output Directory in the user guide for more information.

    Default: FMOD

### 3.1.6 Output Format

Project output format, this should match the FMOD Studio project Surround Speaker Mode.

    Default: Surround_5_1

### 3.1.7 Output Type

Built-in output types that can be used to run the mixer.

    Default: TYPE_AUTODETECT

## 3.2 Localization

### 3.2.1 Locales

List of project locales. This should match the locales configured for the FMOD Studio project. See Localization in the user guide for more information.

Each entry in the list has three members:

1. Locale Name: This is the name of the locale displayed in the UI (e.g. in Blueprints).
2. Locale Code: This must match the locale code used for the corresponding locale in the FMOD Studio project.
3. Default: Make this locale active at startup. Only one locale should be marked as default.

When loading banks, banks which correspond to the active locale are loaded while banks which correspond to any other recognized locale are skipped.

## 3.3 Init

### 3.3.1 Vol 0 Virtual

Controls whether the Vol 0 Virtual Level setting is honored.

    Default: Enabled

### 3.3.2 Vol 0 Virtual Level

Sets the signal level at which Channels are virtualized when the Vol 0 Virtual setting is enabled. This corresponds directly to the `vol0virtual` member of `FMOD_ADVANCED_SETTINGS` in the Core API.

    Default: 0.0001

### 3.3.3 Sample Rate

The sample rate for the FMOD mixer. This corresponds to the `samplerate` parameter of `FMOD::System::setSoftwareFormat` in the Core API.

    Default: 0 (uses the default sample rate for the platform)

### 3.3.4 Match Hardware Sample Rate

When enabled attempt to match the sample rate for the FMOD mixer with the output driver's sample rate.

    Default: Enabled

### 3.3.5 Real Channel Count

The maximum number of active Channels. This corresponds to the `numsoftwarechannels` parameter of `FMOD::System::setSoftwareChannels` in the Core API.

    Default: 64

### 3.3.6 Total Channel Count

The maximum number of Channels to be used in FMOD. This corresponds to the `maxchannels` parameter of `FMOD::Studio::System::initialize` in the Studio API.

    Default: 512

### 3.3.7 DSP Buffer Length

The mixer block length for the FMOD mixer. This corresponds to the `bufferlength` parameter of `FMOD::System::setDSPBufferSize` in the Core API.

    Units: samples
    Default: 0 (uses the default DSP buffer length for the platform)

### 3.3.8 DSP Buffer Count

The number of mixer blocks for the FMOD mixer to use. This corresponds to the `numbuffers` parameter of `FMOD::System::setDSPBufferSize` in the Core API.

    Default: 0 (uses the default DSP buffer count for the platform)

### 3.3.9 File Buffer Size

File buffering chunk size. This corresponds to the `blockalign` parameter of `FMOD::System::setFileSystem` in the Core API.

    Units: bytes
    Default: 2048

### 3.3.10 Studio Update Period

Update period of FMOD Studio. This corresponds to the `studioupdateperiod` member of `FMOD_STUDIO_ADVANCEDSETTINGS` in the Studio API.

    Units: milliseconds
    Default: 0 (uses the default update period for FMOD Studio)

### 3.3.11 Initial Output Driver Name

Name of output driver to choose at start up. If this is not empty the available output drivers are enumerated at start up and if a driver with a matching name is found then that driver is selected for output.

    Default: Empty (uses the default output driver)

### 3.3.12 Lock All Buses

When enabled all buses in the global mixer are locked when the master bank is loaded. This ensures that all buses in the global mixer are created.

    Default: Disabled

### 3.3.13 Memory Pool Sizes

Size of memory pool to use on each platform. When this is set to a value other than zero a memory pool of the requested size is allocated using the Unreal memory system and all FMOD memory allocations are made from the pool. Otherwise FMOD memory allocations directly use the Unreal memory system.

    Units: bytes
    Default: 0

## 3.4 Advanced

### 3.4.1 Live Update Port

TCP port to listen on for FMOD Studio Live Update connections when running non-final builds of the game.

    Default: 9264

### 3.4.2 Editor Live Update Port

TCP port to listen on for FMOD Studio Live Update connections when running the editor.

    Default: 9265

### 3.4.3 Reload Banks Delay

Delay before automatically reloading modified banks from disk. This can be extended if building banks takes a long time and Unreal tries to reload banks before building is completed. Set to 0 to disable automatic bank reloading.

    Units: seconds
    Default: 5

### 3.4.4 Enable API Error Logging

Will log internal API errors when enabled.

    Default: Disabled

### 3.4.5 Enable Memory Tracking

Enables FMOD's detailed memory tracking for non-final builds. This corresponds to setting the `FMOD_STUDIO_INIT_MEMORY_TRACKING` flag into the `studioflags` when initializing the Studio API.

    Default: Disabled

### 3.4.6 Plugin Files

List of FMOD Studio plugins to be loaded when the system starts up. See Plugins for more information.

### 3.4.7 Content Browser Prefix

Root directory for FMOD assets.

    Default: /Game/FMOD

### 3.4.8 Force Platform Name

Override platform name for loading banks at runtime.

    Default: Empty (use default platform name)

### 3.4.9 Master Bank Name

Name of master bank (without extension). Must match the FMOD Studio project.

    Default: Master

### 3.4.10 Skip Load Bank Name

String to filter banks loaded when Load All Banks is enabled. If Skip Load Bank Name is not empty then any bank with a name containing the specified string will be skipped by automatic bank loading.

    Default: Empty

### 3.4.11 Encryption Key

Key for loading encrypted banks. This corresponds to the `encryptionkey` member of `FMOD_STUDIO_ADVANCEDSETTINGS` in the Studio API.

### 3.4.12 Wav Writer Path

File name that the wav writer will output to. If this is not empty then the runtime FMOD Studio system will use `FMOD_OUTPUTTYPE_WAVWRITER` and the mixed audio produced by FMOD will be sent to the specified file. There will be no audible output when using this setting.

    Default: Empty

### 3.4.13 Logging Level

Logging level for non-final builds. The logging levels correspond to the similarly named `FMOD_DEBUG_LEVEL_XXX` flags used by the `FMOD::Debug_Initialize` function in the Core API.

    Default: LEVEL NONE

### 3.4.14 Occlusion Parameter

Name of event parameter to automate using Unreal occlusion ray casts. See Occlusion Settings for more information.

    Default: Empty

### 3.4.15 Ambient Volume Parameter

Name of event parameter to automate using Unreal ambient zone volume settings. See Ambient Zone Settings for more information.

    Default: Empty

### 3.4.16 Ambient LPF Parameter

Name of event parameter to automate using Unreal ambient zone LPF settings. See Ambient Zone Settings for more information.

    Default: Empty

## 3.5 Platform Settings

Used to specify individual settings for different platforms.

### 3.5.1 Platform

Name of the platform.

#### Real Channel Count

The maximum number of active channels. This corresponds to the `numsoftwarechannels` parameter of `FMOD::System::setSoftwareChannels` in the Core API.

    Default: 64

#### Sample Rate

The sample rate for the FMOD mixer. This corresponds to the `samplerate` parameter of `FMOD::System::setSoftwareFormat` in the Core API.

    Default: 0 (uses the default sample rate for the platform)

#### Speaker Mode

Project output format, this should match the FMOD Studio project Surround Speaker Mode.

    Default: Surround_5_1

#### Output Type

Built-in output types that can be used to run the mixer.

    Default: TYPE_AUTODETECT

#### Custom Pool Size

Size of memory pool to use. When this is set to a value other than zero a memory pool of the requested size is allocated using the Unreal memory system and all FMOD memory allocations are made from the pool. Otherwise FMOD memory allocations directly use the Unreal memory system.

    Units: bytes
    Default: 0

#### Codecs

Specifying one or more of the codec maximums will help determine the maximum CPU usage of playing FMOD_CREATECOMPRESSEDSAMPLE Sounds of that type as well as the memory requirements.

## 3.6 Packaging

As well as settings exposed by FMOD For Unreal you will need to add the directory containing the FMOD bank files to the Additional Non-asset Directory To Copy setting in Unreal's Project - Packaging settings. The FMOD Studio settings UI will prompt you to update this setting if it is not correctly configured. See Packaging banks in the user guide for more information.